## kvazaar 2.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(kvazaar
LANGUAGES C CXX
HOMEPAGE_URL https://github.com/ultravideo/kvazaar
DESCRIPTION "An open-source HEVC encoder licensed under 3-clause BSD"
VERSION 2.3.1 )

option(BUILD_SHARED_LIBS "Build using shared kvazaar library" ON)

option(BUILD_TESTS "Build tests" ON)

option(USE_CRYPTO "Use crypto library" OFF)

include(GNUInstallDirs) #Helps to define correct distro specific install directories
set(DEFERRED "@")

set(KVAZAAR_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}" CACHE PATH "kvazaar library install path")
set(KVAZAAR_INSTALL_BINDIR "${CMAKE_INSTALL_BINDIR}" CACHE PATH "kvazaar binary install path")
set(KVAZAAR_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}" CACHE PATH "kvazaar include install path")
set(KVAZAAR_INSTALL_MANDIR "${CMAKE_INSTALL_MANDIR}/man1" CACHE PATH "kvazaar manual page file install path")

# https://www.kitware.com/cmake-and-the-default-build-type/
# Set a default build type if none was specified
set(KVZ_DEFAULT_BUILD_TYPE "RelWithDebInfo")

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "No build type specified, setting to '${KVZ_DEFAULT_BUILD_TYPE}'.")
  set(CMAKE_BUILD_TYPE "${KVZ_DEFAULT_BUILD_TYPE}" CACHE
      STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()


find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
    # Update submodules as needed
    option(GIT_SUBMODULE "Check submodules during build" ON)
    if(GIT_SUBMODULE)
        message(STATUS "Submodule update")
        execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
                        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                        RESULT_VARIABLE GIT_SUBMOD_RESULT)
        if(NOT GIT_SUBMOD_RESULT EQUAL "0")
            message(WARNING "git submodule update --init --recursive failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
        endif()
    endif()
    # Check git hash and fetch tag
    execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                    RESULT_VARIABLE GIT_HEAD_OK
                    OUTPUT_VARIABLE GIT_HEAD)
    if(GIT_HEAD_OK EQUAL "0")
        string(SUBSTRING ${GIT_HEAD} 0 30 GIT_TAG_LONG)    
        execute_process(COMMAND ${GIT_EXECUTABLE} name-rev --tags --name-only ${GIT_TAG_LONG}
                        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                        RESULT_VARIABLE GIT_TAG_OK
                        OUTPUT_VARIABLE GIT_TAG)
        string(SUBSTRING ${GIT_TAG} 0 9 GIT_TAG_STRIP)
      
        # If tag is not defined, add part of the commit hash to the version
        if(GIT_TAG_OK EQUAL "0" AND GIT_TAG_STRIP STREQUAL "undefined")
          string(SUBSTRING ${GIT_HEAD} 0 7 GIT_TAG_SHORT)
          set(PROJECT_VERSION ${PROJECT_VERSION}-${GIT_TAG_SHORT})
          message(INFO " No tag detected, version changed to ${PROJECT_VERSION}")
        endif()
    endif()    
endif()

if(NOT EXISTS "${PROJECT_SOURCE_DIR}/greatest/greatest.h")
    message(WARNING "The submodule greatest was not loaded, some tests may fail")
endif()

# Grab <year>-<month>-<day> timestamp for debug purposes
string(TIMESTAMP CMAKE_BUILD_DATE %Y-%m-%d)

set(KVZ_COMPILER_VERSION "${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}")

if(MSVC)
    if(MSVC_VERSION LESS 1800)
        set(KVZ_COMPILER_VERSION "VS")
    elseif(MSVC_VERSION LESS 1900)
        set(KVZ_COMPILER_VERSION "VS2013")
    elseif(MSVC_VERSION LESS 1910)
        set(KVZ_COMPILER_VERSION "VS2015")
    elseif(MSVC_VERSION LESS 1920)
        set(KVZ_COMPILER_VERSION "VS2017")
    elseif(MSVC_VERSION LESS 1930)
        set(KVZ_COMPILER_VERSION "VS2019")
    else()
        set(KVZ_COMPILER_VERSION "VS2022")
    endif()
endif()

# Set compiler info to print at runtime
set(KVZ_COMPILER_STRING "${KVZ_COMPILER_VERSION}")

add_definitions(-DCMAKE_BUILD)

# Set correct pkgconfig libdir variable
if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
  set(KVAZAAR_PC_LIBDIR "${CMAKE_INSTALL_LIBDIR}")
else()
  set(KVAZAAR_PC_LIBDIR "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
endif()

# Set correct pkgconfig include variable
if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
  set(KVAZAAR_PC_INCDIR "${CMAKE_INSTALL_INCLUDEDIR}")
else()
  set(KVAZAAR_PC_INCDIR "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
endif()

# Apply dynamic info to the config files
configure_file("${PROJECT_SOURCE_DIR}/src/kvazaarCMake.pc.in" "${PROJECT_SOURCE_DIR}/src/kvazaar.pc.temp" @ONLY)
configure_file("${PROJECT_SOURCE_DIR}/src/version.h.in" "${PROJECT_SOURCE_DIR}/src/version.h" @ONLY)

# Add all sources in src/ base
file(GLOB LIB_SOURCES RELATIVE ${PROJECT_SOURCE_DIR} "src/*.h" "src/*.c")

# We don't want CLI main in the library
list(REMOVE_ITEM LIB_SOURCES "src/encmain.c" "src/cli.c" "src/cli.h" "src/yuv_io.c" "src/yuv_io.h")

# Add also all the strategies
file(GLOB_RECURSE LIB_SOURCES_STRATEGIES RELATIVE ${PROJECT_SOURCE_DIR} "src/strategies/*.c")

list(APPEND LIB_SOURCES ${LIB_SOURCES_STRATEGIES})

# We also need the libmd5
list(APPEND LIB_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/extras/libmd5.c)

add_definitions(-DKVZ_DLL_EXPORTS)

if(BUILD_SHARED_LIBS)
  add_definitions(-DPIC)
endif()

# For visual studio / windows we also need our own pthread implementation and getopt
if(MSVC)
  list(APPEND LIB_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/extras/getopt.c ${CMAKE_CURRENT_SOURCE_DIR}/src/threadwrapper/src/pthread.cpp ${CMAKE_CURRENT_SOURCE_DIR}/src/threadwrapper/src/semaphore.cpp)
  add_definitions(-DWIN32_LEAN_AND_MEAN -D_WIN32 -DWIN32 -DWIN64)
endif()


if (USE_CRYPTO)
    if(BUILD_TESTS)
        message(WARNING "Crypto++ is not compatible with the tests, disabling tests")
        set(BUILD_TESTS OFF)
    endif()
    if (BUILD_SHARED_LIBS)
        message(WARNING "Crypto++ is not compatible with shared libraries, disabling shared libraries")
        set(BUILD_SHARED_LIBS OFF)
    endif ()
    include(FetchContent)

    add_definitions(-DKVZ_SEL_ENCRYPTION)
    list(APPEND LIB_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/extras/crypto.cpp)
    list(APPEND CLI_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/extras/crypto.cpp)

    if (NOT CRYPTOPP_FOUND)
        message(STATUS "Fetching and building Crypto++")

        # CMake for Crypto++
        FetchContent_Declare(
                cryptopp-cmake
                GIT_REPOSITORY https://github.com/abdes/cryptopp-cmake.git
                GIT_TAG        43367a9cef6576b34179427a31a619802205406e
        )

        set(CRYPTOPP_INSTALL OFF CACHE BOOL "" FORCE) # we don't want to install Crypto++
        set(CRYPTOPP_BUILD_TESTING OFF CACHE BOOL "" FORCE)
        set(BUILD_SHARED_LIBS OFF CACHE BOOL "" FORCE)

        FetchContent_MakeAvailable(cryptopp-cmake)

        unset(BUILD_SHARED_LIBS) # unset so it does not affect other projects

        # copy lib binary so it is found later
        file(GLOB CRYPTOPP_BIN "${cryptopp-cmake_BINARY_DIR}/cryptopp/cryptopp.*")
        file(COPY ${CRYPTOPP_BIN} DESTINATION ${CMAKE_BINARY_DIR}/lib/)
        file(GLOB CRYPTOPP_BIN "${cryptopp-cmake_BINARY_DIR}/cryptopp/libcryptopp.*")
        file(COPY ${CRYPTOPP_BIN} DESTINATION ${CMAKE_BINARY_DIR}/lib/)
    endif ()


endif ()

if(BUILD_SHARED_LIBS)
  list( APPEND CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_LIBDIR}" "./" "../lib" )
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  add_library(kvazaar SHARED ${LIB_SOURCES})
else()
  add_library(kvazaar STATIC ${LIB_SOURCES})
  if(MSVC) # Fix a linking problem with visual studio when the library is the same name as the binary
    set_target_properties(kvazaar PROPERTIES OUTPUT_NAME libkvazaar)
  endif()
  
endif()

target_include_directories(kvazaar PUBLIC src)
target_include_directories(kvazaar PUBLIC src/extras)
target_include_directories(kvazaar PUBLIC src/strategies)

file(GLOB LIB_SOURCES_STRATEGIES_AVX2 RELATIVE ${PROJECT_SOURCE_DIR} "src/strategies/avx2/*.c")
file(GLOB LIB_SOURCES_STRATEGIES_SSE41 RELATIVE ${PROJECT_SOURCE_DIR} "src/strategies/sse41/*.c")

set(CLI_SOURCES "src/encmain.c" "src/cli.c" "src/cli.h" "src/yuv_io.c" "src/yuv_io.h")

# Add the getopt and pthread for visual studio
if(MSVC) 
  list(APPEND CLI_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/extras/getopt.c ${CMAKE_CURRENT_SOURCE_DIR}/src/threadwrapper/src/pthread.cpp ${CMAKE_CURRENT_SOURCE_DIR}/src/threadwrapper/src/semaphore.cpp)
endif()

add_executable(kvazaar-bin ${CLI_SOURCES})

set_target_properties(kvazaar-bin PROPERTIES OUTPUT_NAME kvazaar)
set_target_properties(kvazaar-bin PROPERTIES RUNTIME_OUTPUT_NAME kvazaar)

target_link_libraries(kvazaar-bin PUBLIC kvazaar)

if(MSVC)
  target_include_directories(kvazaar PUBLIC src/threadwrapper/include)
  set_property( SOURCE ${LIB_SOURCES_STRATEGIES_AVX2} APPEND PROPERTY COMPILE_FLAGS "/arch:AVX2" )  
else()
  set_target_properties(kvazaar-bin PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src)
  set_target_properties(kvazaar PROPERTIES SOVERSION "7" VERSION "7.4.0")
  list(APPEND ALLOW_AVX2 "x86_64" "AMD64")
  if(${CMAKE_SYSTEM_PROCESSOR} IN_LIST ALLOW_AVX2) 
    set_property( SOURCE ${LIB_SOURCES_STRATEGIES_AVX2} APPEND PROPERTY COMPILE_FLAGS "-mavx2 -mbmi -mpopcnt -mlzcnt -mbmi2" )
    set_property( SOURCE ${LIB_SOURCES_STRATEGIES_SSE41} APPEND PROPERTY COMPILE_FLAGS "-msse4.1" )    
  endif()
  
  # CYGWIN, MSYS, and MINGW seem to be needing this but in some cases 
  # it might be that the toolset is not properly set, so also use this
  # in cases where we are not sure that it is not needed
  if((NOT MSVC AND NOT LINUX AND NOT APPLE) OR (CYGWIN OR MSYS OR MINGW))
    set(CMAKE_C_FLAGS "-Wa,-muse-unaligned-vector-move ${CMAKE_C_FLAGS}")
  endif()

  
  set(THREADS_PREFER_PTHREAD_FLAG ON)
  find_package(Threads REQUIRED)
  target_link_libraries(kvazaar PUBLIC Threads::Threads)

  include(CheckLibraryExists)

  CHECK_LIBRARY_EXISTS(m sin "" HAVE_LIB_M)

  if (HAVE_LIB_M)
      set(EXTRA_LIBS ${EXTRA_LIBS} m)
  endif (HAVE_LIB_M)
  if (USE_CRYPTO)
      set(EXTRA_LIBS ${EXTRA_LIBS} ${CMAKE_BINARY_DIR}/lib/libcryptopp.a)
  endif ()

  target_link_libraries(kvazaar PUBLIC ${EXTRA_LIBS})
  target_link_libraries(kvazaar-bin PUBLIC ${EXTRA_LIBS} )
endif()


# Source grouping

# Some basic structuring of the files based on previous visual studio project files
file(GLOB SOURCE_GROUP_BITSTREAM RELATIVE ${PROJECT_SOURCE_DIR} "src/encode_coding_tree.*" "src/encoder_state-bitstream.*" "src/nal.*")
file(GLOB SOURCE_GROUP_CABAC RELATIVE ${PROJECT_SOURCE_DIR} "src/bitstream.*" "src/cabac.*" "src/context.*")
file(GLOB SOURCE_GROUP_COMPRESSION RELATIVE ${PROJECT_SOURCE_DIR} "src/search*" "src/rdo.*" "src/fast_coeff*")
file(GLOB SOURCE_GROUP_CONSTRAINT RELATIVE ${PROJECT_SOURCE_DIR} "src/constraint.*" "src/ml_*")
file(GLOB SOURCE_GROUP_CONTROL RELATIVE ${PROJECT_SOURCE_DIR} "src/cfg.*" "src/encoder.*" "src/encoder_state-c*" "src/encoder_state-g*" "src/encoderstate*" "src/gop.*" "src/input_frame_buffer.*" "src/kvazaar*" "src/rate_control.*" "src/mip_data.h")
file(GLOB SOURCE_GROUP_DATA_STRUCTURES RELATIVE ${PROJECT_SOURCE_DIR} "src/cu.*" "src/image.*" "src/imagelist.*" "src/videoframe.*")
file(GLOB SOURCE_GROUP_EXTRAS RELATIVE ${PROJECT_SOURCE_DIR} "src/extras/*.h" "src/extras/*.c")
file(GLOB_RECURSE SOURCE_GROUP_STRATEGIES RELATIVE ${PROJECT_SOURCE_DIR} "src/strategies/*.h" "src/strategies/*.c")
file(GLOB SOURCE_GROUP_RECON RELATIVE ${PROJECT_SOURCE_DIR} "src/alf.*" "src/filter.*" "src/inter.*" "src/intra.*" "src/reshape.*" "src/sao.*" "src/scalinglist.*" "src/tables.*" "src/transform.*")
file(GLOB SOURCE_GROUP_THREADING RELATIVE ${PROJECT_SOURCE_DIR} "src/threadqueue.*" "src/threads.*")
file(GLOB_RECURSE SOURCE_GROUP_THREADWRAPPER RELATIVE ${PROJECT_SOURCE_DIR} "src/threadwrapper/*.cpp" "src/threadwrapper/*.h")

=== tests/CMakeLists.txt ===
file( GLOB TEST_SOURCES "*.c" )

# ToDo: fix the tests
list(REMOVE_ITEM TEST_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/inter_recon_bipred_tests.c")

add_executable(kvazaar_tests ${TEST_SOURCES} )

target_include_directories(kvazaar_tests PUBLIC ${PROJECT_SOURCE_DIR})
target_include_directories(kvazaar_tests PUBLIC ${PROJECT_SOURCE_DIR}/src)
target_include_directories(kvazaar_tests PUBLIC ${PROJECT_SOURCE_DIR}/src/extras)

add_definitions(-DKVZ_DLL_EXPORTS)

if(BUILD_SHARED_LIBS)
  add_definitions(-DPIC)
endif()

if(MSVC)
  target_include_directories(kvazaar_tests PUBLIC ../src/threadwrapper/include)

  set_property( SOURCE ${TEST_SOURCES}  APPEND PROPERTY COMPILE_FLAGS "/arch:AVX2" )
  add_definitions(-DWIN32_LEAN_AND_MEAN -D_WIN32 -DWIN32 -DWIN64)
else()
  list(APPEND ALLOW_AVX2 "x86_64" "AMD64")
  if(${CMAKE_SYSTEM_PROCESSOR} IN_LIST ALLOW_AVX2) 
    set_property( SOURCE ${TEST_SOURCES}  APPEND PROPERTY COMPILE_FLAGS "-mavx2 -mbmi -mpopcnt -mlzcnt -mbmi2" )
  endif()
  find_package(Threads REQUIRED)
  target_link_libraries(kvazaar_tests PUBLIC Threads::Threads)

  include(CheckLibraryExists)

  CHECK_LIBRARY_EXISTS(m sin "" HAVE_LIB_M)

  if (HAVE_LIB_M)
      set(EXTRA_LIBS ${EXTRA_LIBS} m)
  endif (HAVE_LIB_M)

  target_link_libraries(kvazaar_tests PUBLIC ${EXTRA_LIBS})
endif()

target_link_libraries(kvazaar_tests PUBLIC kvazaar)

=== debian/changelog ===
kvazaar (2.3.1-3) unstable; urgency=medium

  * Change to use my @debian.org address.
  * Add patch from upstream to fix compilation with gcc-15.
  * d/control: Update Standards-Version to 4.7.2

 -- Joachim Bauch <fancycode@debian.org>  Tue, 19 Aug 2025 08:31:20 +0200

kvazaar (2.3.1-2) unstable; urgency=medium

  [ Alex Myczko ]
  * allow double builds

  [ Joachim Bauch ]
  * Add patch from upstream to fix hanging tests on i386.
  * No need to forward privacy-related patch.
  * d/rules: Run tests on all platforms again. (Closes: #1078175)

 -- Joachim Bauch <bauch@struktur.de>  Tue, 20 Aug 2024 23:35:07 +0200

kvazaar (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Remove patch no longer necessary with new upstream version.
  * d/control: Update "Standards-Version" to 4.7.0
  * d/control: Mark "-doc" package as "Multi-Arch: foreign".
  * d/rules: Disable tests on platforms where they timeout.
  * Only run doxygen when building indep packages.
  * d/control: Migrate to "pkgconf".

 -- Joachim Bauch <bauch@struktur.de>  Wed, 22 May 2024 11:41:54 +0200

kvazaar (2.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1060341)

 -- Joachim Bauch <bauch@struktur.de>  Mon, 22 Jan 2024 21:05:38 +0100

=== debian/control ===
Source: kvazaar
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Joachim Bauch <fancycode@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ffmpeg,
 hm,
 libcrypto++-dev,
 pkgconf
Build-Depends-Indep:
 doxygen,
 graphviz
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/ultravideo/kvazaar
Vcs-Browser: https://salsa.debian.org/multimedia-team/kvazaar
Vcs-Git: https://salsa.debian.org/multimedia-team/kvazaar.git

Package: kvazaar
Section: video
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEVC encoder - application
 kvazaar is a HEVC encoder.
 .
 This package contains the kvazaar application.

Package: libkvazaar7
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEVC encoder - shared library
 kvazaar is a HEVC encoder.
 .
 This package contains the shared library.

Package: libkvazaar-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libkvazaar7 (= ${binary:Version}),
 ${misc:Depends}
Suggests:
 kvazaar-doc
Description: HEVC encoder - development files
 kvazaar is a HEVC encoder.
 .
 The development headers for compiling programs that use kvazaar are provided
 by this package.

Package: kvazaar-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: HEVC encoder - documentation
 kvazaar is a HEVC encoder.
 .
 This package contains the documentation.

## kvazaar 2.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,18 @@
-cmake_minimum_required(VERSION 3.12)
+cmake_minimum_required(VERSION 3.25)
 
 project(kvazaar
 LANGUAGES C CXX
 HOMEPAGE_URL https://github.com/ultravideo/kvazaar
 DESCRIPTION "An open-source HEVC encoder licensed under 3-clause BSD"
-VERSION 2.3.1 )
+VERSION 2.3.2 )
 
 option(BUILD_SHARED_LIBS "Build using shared kvazaar library" ON)
 
 option(BUILD_TESTS "Build tests" ON)
 
 option(USE_CRYPTO "Use crypto library" OFF)
+
+option(BUILD_KVAZAAR_BINARY "Build kvazaar-bin" ON) # To build only the lib, useful for iOS-builds
 
 include(GNUInstallDirs) #Helps to define correct distro specific install directories
 set(DEFERRED "@")
@@ -213,20 +215,41 @@
   list(APPEND CLI_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/extras/getopt.c ${CMAKE_CURRENT_SOURCE_DIR}/src/threadwrapper/src/pthread.cpp ${CMAKE_CURRENT_SOURCE_DIR}/src/threadwrapper/src/semaphore.cpp)
 endif()
 
-add_executable(kvazaar-bin ${CLI_SOURCES})
-
-set_target_properties(kvazaar-bin PROPERTIES OUTPUT_NAME kvazaar)
-set_target_properties(kvazaar-bin PROPERTIES RUNTIME_OUTPUT_NAME kvazaar)
-
-target_link_libraries(kvazaar-bin PUBLIC kvazaar)
+if(BUILD_KVAZAAR_BINARY)
+  add_executable(kvazaar-bin ${CLI_SOURCES})
+
+  if(MSVC AND BUILD_SHARED_LIBS)
+    set_target_properties(kvazaar PROPERTIES
+      OUTPUT_NAME kvazaar
+      PDB_NAME kvazaar-lib
+    )
+
+    set_target_properties(kvazaar-bin PROPERTIES
+      OUTPUT_NAME kvazaar
+      PDB_NAME kvazaar-bin
+    )
+  else()
+    set_target_properties(kvazaar-bin PROPERTIES
+      OUTPUT_NAME kvazaar
+    )
+  endif()
+  set_target_properties(kvazaar-bin PROPERTIES RUNTIME_OUTPUT_NAME kvazaar)
+
+  target_link_libraries(kvazaar-bin PUBLIC kvazaar)
+endif()
+
+list(APPEND ALLOW_AVX2 "x86_64" "AMD64")
 
 if(MSVC)
   target_include_directories(kvazaar PUBLIC src/threadwrapper/include)
-  set_property( SOURCE ${LIB_SOURCES_STRATEGIES_AVX2} APPEND PROPERTY COMPILE_FLAGS "/arch:AVX2" )  
-else()
-  set_target_properties(kvazaar-bin PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src)
+  if(${CMAKE_SYSTEM_PROCESSOR} IN_LIST ALLOW_AVX2) 
+    set_property( SOURCE ${LIB_SOURCES_STRATEGIES_AVX2} APPEND PROPERTY COMPILE_FLAGS "/arch:AVX2" )  
+  endif()
+else()
+  if(BUILD_KVAZAAR_BINARY)
+    set_target_properties(kvazaar-bin PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src)
+  endif()
   set_target_properties(kvazaar PROPERTIES SOVERSION "7" VERSION "7.4.0")
-  list(APPEND ALLOW_AVX2 "x86_64" "AMD64")
   if(${CMAKE_SYSTEM_PROCESSOR} IN_LIST ALLOW_AVX2) 
     set_property( SOURCE ${LIB_SOURCES_STRATEGIES_AVX2} APPEND PROPERTY COMPILE_FLAGS "-mavx2 -mbmi -mpopcnt -mlzcnt -mbmi2" )
     set_property( SOURCE ${LIB_SOURCES_STRATEGIES_SSE41} APPEND PROPERTY COMPILE_FLAGS "-msse4.1" )    
@@ -235,14 +258,15 @@
   # CYGWIN, MSYS, and MINGW seem to be needing this but in some cases 
   # it might be that the toolset is not properly set, so also use this
   # in cases where we are not sure that it is not needed
-  if((NOT MSVC AND NOT LINUX AND NOT APPLE) OR (CYGWIN OR MSYS OR MINGW))
+  if((NOT MSVC AND NOT LINUX AND NOT APPLE AND NOT ANDROID AND NOT EMSCRIPTEN AND NOT BSD) OR (CYGWIN OR MSYS OR MINGW))
     set(CMAKE_C_FLAGS "-Wa,-muse-unaligned-vector-move ${CMAKE_C_FLAGS}")
   endif()
 
-  
-  set(THREADS_PREFER_PTHREAD_FLAG ON)
-  find_package(Threads REQUIRED)
-  target_link_libraries(kvazaar PUBLIC Threads::Threads)
+  if(NOT ANDROID AND NOT EMSCRIPTEN)
+    set(THREADS_PREFER_PTHREAD_FLAG ON)
+    find_package(Threads REQUIRED)
+    target_link_libraries(kvazaar PUBLIC Threads::Threads)
+  endif()
 
   include(CheckLibraryExists)
 
@@ -256,7 +280,9 @@
   endif ()
 
   target_link_libraries(kvazaar PUBLIC ${EXTRA_LIBS})
-  target_link_libraries(kvazaar-bin PUBLIC ${EXTRA_LIBS} )
+  if(BUILD_KVAZAAR_BINARY)
+    target_link_libraries(kvazaar-bin PUBLIC ${EXTRA_LIBS} )
+  endif()
 endif()
 
 
@@ -269,8 +295,3 @@
 file(GLOB SOURCE_GROUP_CONSTRAINT RELATIVE ${PROJECT_SOURCE_DIR} "src/constraint.*" "src/ml_*")
 file(GLOB SOURCE_GROUP_CONTROL RELATIVE ${PROJECT_SOURCE_DIR} "src/cfg.*" "src/encoder.*" "src/encoder_state-c*" "src/encoder_state-g*" "src/encoderstate*" "src/gop.*" "src/input_frame_buffer.*" "src/kvazaar*" "src/rate_control.*" "src/mip_data.h")
 file(GLOB SOURCE_GROUP_DATA_STRUCTURES RELATIVE ${PROJECT_SOURCE_DIR} "src/cu.*" "src/image.*" "src/imagelist.*" "src/videoframe.*")
-file(GLOB SOURCE_GROUP_EXTRAS RELATIVE ${PROJECT_SOURCE_DIR} "src/extras/*.h" "src/extras/*.c")
-file(GLOB_RECURSE SOURCE_GROUP_STRATEGIES RELATIVE ${PROJECT_SOURCE_DIR} "src/strategies/*.h" "src/strategies/*.c")
-file(GLOB SOURCE_GROUP_RECON RELATIVE ${PROJECT_SOURCE_DIR} "src/alf.*" "src/filter.*" "src/inter.*" "src/intra.*" "src/reshape.*" "src/sao.*" "src/scalinglist.*" "src/tables.*" "src/transform.*")
-file(GLOB SOURCE_GROUP_THREADING RELATIVE ${PROJECT_SOURCE_DIR} "src/threadqueue.*" "src/threads.*")
-file(GLOB_RECURSE SOURCE_GROUP_THREADWRAPPER RELATIVE ${PROJECT_SOURCE_DIR} "src/threadwrapper/*.cpp" "src/threadwrapper/*.h")

=== greatest/Makefile ===
CFLAGS += -Wall -Werror -Wextra -pedantic
CFLAGS += -Wmissing-prototypes
CFLAGS += -Wstrict-prototypes
CFLAGS += -Wmissing-declarations

# Uncomment to demo c99 parametric testing.
#CFLAGS += -std=c99

# Uncomment to disable setjmp()/longjmp().
#CFLAGS += -DGREATEST_USE_LONGJMP=0

# Uncomment to disable clock() / time.h.
#CFLAGS += -DGREATEST_USE_TIME=0

all: example

example: example.c greatest.h example-suite.o
	${CC} -o $@ example.c example-suite.o ${CFLAGS} ${LDFLAGS}

clean:
	rm -f example *.o *.core

example-suite.o: example-suite.c

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -15,18 +15,24 @@
   add_definitions(-DPIC)
 endif()
 
+list(APPEND ALLOW_AVX2 "x86_64" "AMD64")
+
 if(MSVC)
   target_include_directories(kvazaar_tests PUBLIC ../src/threadwrapper/include)
 
-  set_property( SOURCE ${TEST_SOURCES}  APPEND PROPERTY COMPILE_FLAGS "/arch:AVX2" )
+  if(${CMAKE_SYSTEM_PROCESSOR} IN_LIST ALLOW_AVX2) 
+    set_property( SOURCE ${TEST_SOURCES}  APPEND PROPERTY COMPILE_FLAGS "/arch:AVX2" )
+  endif()
   add_definitions(-DWIN32_LEAN_AND_MEAN -D_WIN32 -DWIN32 -DWIN64)
 else()
-  list(APPEND ALLOW_AVX2 "x86_64" "AMD64")
   if(${CMAKE_SYSTEM_PROCESSOR} IN_LIST ALLOW_AVX2) 
     set_property( SOURCE ${TEST_SOURCES}  APPEND PROPERTY COMPILE_FLAGS "-mavx2 -mbmi -mpopcnt -mlzcnt -mbmi2" )
   endif()
-  find_package(Threads REQUIRED)
-  target_link_libraries(kvazaar_tests PUBLIC Threads::Threads)
+
+  if(NOT ANDROID)
+    find_package(Threads REQUIRED)
+    target_link_libraries(kvazaar_tests PUBLIC Threads::Threads)
+  endif()
 
   include(CheckLibraryExists)

=== debian/changelog ===
kvazaar (2.3.2-1) unstable; urgency=medium

  * Mention closed bug in changelog.
  * Add autopkgtests that run the upstream tests.
  * d/control: Improve package description.
  * New upstream version 2.3.2
  * Remove patches applied upstream.

 -- Joachim Bauch <fancycode@debian.org>  Wed, 01 Oct 2025 22:50:29 +0200

=== debian/control ===
--- 
+++ 
@@ -26,7 +26,19 @@
  ${misc:Depends},
  ${shlibs:Depends}
 Description: HEVC encoder - application
- kvazaar is a HEVC encoder.
+ Kvazaar is an award-winning academic open-source video encoder for the
+ state-of-the-art High Efficiency Video Coding (HEVC/H.265) standard.
+ .
+ Kvazaar is being developed in C and optimized in SSE/AVX intrinsics. The
+ development is being coordinated by Ultra Video Group at Tampere University,
+ Finland.
+ .
+ Kvazaar includes all coding tools of Main, Main 10, and Main Still Picture
+ profiles of HEVC and its modular source code facilitates parallelization on
+ multi and manycore processors as well as algorithm acceleration on hardware.
+ .
+ This cross-platform HEVC encoder is targeted at x86, x64, PowerPC, and ARM
+ processors.
  .
  This package contains the kvazaar application.
 
@@ -37,7 +49,19 @@
  ${misc:Depends},
  ${shlibs:Depends}
 Description: HEVC encoder - shared library
- kvazaar is a HEVC encoder.
+ Kvazaar is an award-winning academic open-source video encoder for the
+ state-of-the-art High Efficiency Video Coding (HEVC/H.265) standard.
+ .
+ Kvazaar is being developed in C and optimized in SSE/AVX intrinsics. The
+ development is being coordinated by Ultra Video Group at Tampere University,
+ Finland.
+ .
+ Kvazaar includes all coding tools of Main, Main 10, and Main Still Picture
+ profiles of HEVC and its modular source code facilitates parallelization on
+ multi and manycore processors as well as algorithm acceleration on hardware.
+ .
+ This cross-platform HEVC encoder is targeted at x86, x64, PowerPC, and ARM
+ processors.
  .
  This package contains the shared library.
 
@@ -51,7 +75,19 @@
 Suggests:
  kvazaar-doc
 Description: HEVC encoder - development files
- kvazaar is a HEVC encoder.
+ Kvazaar is an award-winning academic open-source video encoder for the
+ state-of-the-art High Efficiency Video Coding (HEVC/H.265) standard.
+ .
+ Kvazaar is being developed in C and optimized in SSE/AVX intrinsics. The
+ development is being coordinated by Ultra Video Group at Tampere University,
+ Finland.
+ .
+ Kvazaar includes all coding tools of Main, Main 10, and Main Still Picture
+ profiles of HEVC and its modular source code facilitates parallelization on
+ multi and manycore processors as well as algorithm acceleration on hardware.
+ .
+ This cross-platform HEVC encoder is targeted at x86, x64, PowerPC, and ARM
+ processors.
  .
  The development headers for compiling programs that use kvazaar are provided
  by this package.
@@ -63,6 +99,18 @@
 Depends:
  ${misc:Depends}
 Description: HEVC encoder - documentation
- kvazaar is a HEVC encoder.
+ Kvazaar is an award-winning academic open-source video encoder for the
+ state-of-the-art High Efficiency Video Coding (HEVC/H.265) standard.
+ .
+ Kvazaar is being developed in C and optimized in SSE/AVX intrinsics. The
+ development is being coordinated by Ultra Video Group at Tampere University,
+ Finland.
+ .
+ Kvazaar includes all coding tools of Main, Main 10, and Main Still Picture
+ profiles of HEVC and its modular source code facilitates parallelization on
+ multi and manycore processors as well as algorithm acceleration on hardware.
+ .
+ This cross-platform HEVC encoder is targeted at x86, x64, PowerPC, and ARM
+ processors.
  .
  This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

RUN_TESTS := yes
ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  $(warning Disabling checks due DEB_BUILD_OPTIONS)
  RUN_TESTS := no
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --with-cryptopp

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	doxygen docs.doxy

override_dh_auto_install-arch:
	dh_auto_install

override_dh_auto_install-indep:
	mkdir -p debian/tmp/usr/share/doc/kvazaar/
	cp -r doxygen_html debian/tmp/usr/share/doc/kvazaar/html

override_dh_auto_test-arch:
ifeq (yes,$(RUN_TESTS))
	dh_auto_test
else
	echo 'nocheck found in DEB_BUILD_OPTIONS or unsupported architecture'
endif

override_dh_auto_test-indep:
	# No tests for architecture independent packages.

override_dh_installdocs:
	rm -f debian/tmp/usr/share/doc/kvazaar/LICENSE*
	dh_installdocs

=== debian/tests/control ===
Tests: run-tests
Depends:
 ffmpeg,
 hm,
 kvazaar
Restrictions:

=== debian/watch ===
version=4
opts="searchmode=plain" \
https://api.github.com/repos/ultravideo/kvazaar/releases?per_page=50 \
https://github.com/[^/]+/[^/]+/releases/download/[^/]+/kvazaar-v?@ANY_VERSION@.tar.gz
